const puppeteer= require("tiny-puppeteer");
const { yellow, red, cyan, blue } = require('kleur');

module.exports = function f(urls, options = {}) {
  ;(async()=> {
    const launchOptions = Object.assign({
      headless: true,
    }, options.launchOptions || {});
    const errors = {};

    urls.reduce((promise, item) => {
      const { url } = item;
      return promise
        .then(async () => {
          const browser = await puppeteer.launch(launchOptions);
          const page = await browser.newPage();
      
          page.on('error', error => {
            errors[url] = error;
            // console.log(`Error happen at the page ${blue(url)}: `, error);
          });
        
          page.on('pageerror', pageerr=> {
            errors[url] = pageerr;
            // console.log(`Pageerror occurred at ${blue(url)}: `, pageerr);
          })
          
          console.log(yellow(`\n正在检测 ${blue(url)} ...`))
          try {
            await page.goto(url);
          } catch (error) {
            errors[url] = error;
            console.log(red(`Error at ${blue(url)}:`, error));
          }
          if (!errors[url]) {
            console.log(cyan(`完成检测 ${blue(url)}`))
          } else {
            console.log(red(`${blue(url)} 有报错：`), errors[url])
          }
          await browser.close();
        })
        .catch(e => {
          console.log(url, e)
        });
    }, Promise.resolve()).then(() => {
      const keys = Object.keys(errors)
      if (keys.length === 0) {
        console.log(cyan('恭喜你，没有发现页面有报错！'))
        options.onSuccess && options.onSuccess();
      } else {
        console.log(red(`请检查！发现下面 ${keys.length} 个页面有报错：`))
        console.log(red(JSON.stringify(keys, null, 4)))
        options.onError && options.onError(errors);
      }
    })
  })();
}
